; These have been embeded in jcpplisp.cpp
; gensym.lisp

(defparameter *gensym-counter* 1000)

(defun mod (x y)
    (let ((n (floor (/ x y))))
	(- x (* n y)) ) )

;(defun mod (u k)
;    (cond
;        ((< u k) u)
;	(t (mod (- u k) k)) ) )

(defun int-to-string (i)
    (let ((ans nil) (j))
	(loop
	    (setq j (mod i 10))
	    (setq i (floor (/ i 10)))
	    (setq ans (cons (code-char (+ (char-code #\0) j)) ans))
	    (if (zerop i) (return (coerce ans 'string))) ) ) )

(defun gensym (&rest b)
    (cond
	((null b) (make-symbol (coerce (append '(#\G)
					  (coerce (int-to-string (setq *gensym-counter* (1+ *gensym-counter*))) 'list)
				  ) 'string)) )
	((and (integerp (car b) (< 0 (car b)))) (make-symbol (coerce (append '(#\G)
					  (coerce (int-to-string (car b)) 'list)
				  ) 'string)) )
	((stringp (car b)) (make-symbol (coerce (append (coerce (car b) 'list)
					     (coerce (int-to-string (setq *gensym-counter* (1+ *gensym-counter*))) 'list)
				  ) 'string)) )
	(t (error "BAD USAGE GENSYM"))
    ) )

(defun make-symbol (str)
    (intern-wide str) )

;(print 'end)

